﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.98
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private XUI As XUI
End Sub

Public Sub FitImageToView(bmp As B4XBitmap, ImageView As B4XView)
	'this sub is not really needed
	ImageView.SetBitmap(bmp.Resize(ImageView.Width, ImageView.Height, True))
End Sub

Public Sub FillImageToView(bmp As B4XBitmap, ImageView As B4XView)
	Dim bmpRatio As Float = bmp.Width / bmp.Height
	Dim viewRatio As Float = ImageView.Width / ImageView.Height
	If viewRatio > bmpRatio Then
		Dim NewHeight As Int = bmp.Width / viewRatio
		bmp = bmp.Crop(0, bmp.Height / 2 - NewHeight / 2, bmp.Width, NewHeight)
	Else if viewRatio < bmpRatio Then
		Dim NewWidth As Int = bmp.Height * viewRatio
		bmp = bmp.Crop(bmp.Width / 2 - NewWidth / 2, 0, NewWidth, bmp.Height)
	End If
	ImageView.SetBitmap(bmp.Resize(ImageView.Width, ImageView.Height, True))
End Sub

Public Sub setColorDrawable (view As View, color As Int, radius As Int)
	#if B4A
	Dim cd As ColorDrawable
	cd.Initialize(color, radius)
	view.Background = cd
	#else if B4I
	view.Color = color
	view.SetBorder(9, Colors.Transparent, radius)
	#End If
End Sub

Public Sub SetPadding(v As View, Left As Int, Top As Int, Right As Int, Bottom As Int)
	#if B4A
	Dim jo As JavaObject = v
	jo.RunMethod("setPadding", Array As Object(Left, Top, Right, Bottom))
	#else if B4I
	Dim pnl As Panel
	pnl.Initialize("")
	pnl.SetLayoutAnimated(0, 1, Left, Top, Right, Bottom)
	Dim no As NativeObject = v
	no.SetField("leftView", pnl)
	no.SetField("leftViewMode", 3)
	#End If
End Sub

Public Sub Ajusta_ImagemCS(pastaImagem As String, nomeImagem As String, tamX As Int, tamY As Int) As Bitmap
	Dim ivImagem As ImageView
	ivImagem.Initialize("")
	Dim scale As Float = GetDeviceLayoutValues.NonnormalizedScale
	ivImagem.Bitmap = LoadBitmapResize(pastaImagem,nomeImagem,tamX * scale,tamY * scale,True)
	Return ivImagem.Bitmap
'	ivImagem.Bitmap = XUI.LoadBitmapResize(pastaImagem, nomeImagem, ivImagem.Width, ivImagem.Height, True)
'	Dim bmp As B4XBitmap = XUI.LoadBitmap(pastaImagem, nomeImagem)
'	FillImageToView(bmp, ivImagem)
End Sub

Public Sub Ajusta_Imagem1(ivImagem As ImageView,pastaImagem As String,nomeImagem As String)
	Dim scale As Float = GetDeviceLayoutValues.NonnormalizedScale
	ivImagem.Bitmap = LoadBitmapResize(pastaImagem,nomeImagem,ivImagem.Width * scale,ivImagem.Height * scale,True)
'	ivImagem.Bitmap = XUI.LoadBitmapResize(pastaImagem, nomeImagem, ivImagem.Width, ivImagem.Height, True)
'	Dim bmp As B4XBitmap = XUI.LoadBitmap(pastaImagem, nomeImagem)
'	FillImageToView(bmp, ivImagem)
End Sub

Sub AppendImage(cs As CSBuilder, bmp As Bitmap, tamX As Int, tamY As Int)
	Dim attachment As NativeObject
	attachment = attachment.Initialize("NSTextAttachment").RunMethod("new", Null)
	attachment.SetField("image", bmp)
	Dim nme As NativeObject = Me
	'set bounds
	nme.RunMethod("SetBounds::", Array(attachment, attachment.MakeRect(0, 0, tamX, tamY)))
	Dim attributedString As NativeObject
	attributedString = attributedString.Initialize("NSAttributedString") _
     .RunMethod("attributedStringWithAttachment:", Array(attachment))
	Dim no As NativeObject = cs
	no.RunMethod("appendAttributedString:", Array(attributedString))
'	cs.Append(""&CRLF)
End Sub

#if OBJC
-(void)SetBounds:(NSTextAttachment*) attachment :(NSData*)data {
   attachment.bounds = *(CGRect*)data.bytes;
}
#End If